from math import sqrt


class Rectangle(object):
    '''
    Class representation of a rectangle.
    '''
    def __init__(self, name, a=(0.0, 0.0), b=(1.0, 0.0), c=(1.0, 1.0), d=(0.0, 1.0)):
        self.a = a
        self.b = b
        self.c = c
        self.d = d
        self.name = name

    def __call__(self):
        print("This rectangle is being called!")

    def __repr__(self):
        output_str = self.name +":\n" + str(self.a) + ", " + str(self.b) + ", " + str(self.c) + ", " + str(self.d)
        return output_str

    def __str__(self):
        output_str = "This rectangle is called %s." % self.name
        return output_str

    def __eq__(self, other):
        return self.a == other.a and self.b == other.b and self.c == other.c and self.d == other.d

    def calculate_area(self):
        base = sqrt(((self.b[1] - self.a[1]) ** 2) + ((self.b[0] - self.a[0]) ** 2))
        height = sqrt(((self.c[1] - self.b[1]) ** 2) + ((self.c[0] - self.b[0]) ** 2))
        return base * height


if __name__ == '__main__':
    rect1 = Rectangle("MyRectangle")
    area = rect1.calculate_area(5.0)
    print(area)
